var TykDeveloperPortal =
webpackJsonpTykDeveloperPortal([1],{

/***/ 320:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function($) {

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = __webpack_require__(29);

var _react2 = _interopRequireDefault(_react);

var _reactDom = __webpack_require__(82);

var _reactDom2 = _interopRequireDefault(_reactDom);

var _immutable = __webpack_require__(31);

__webpack_require__(116);

var _swaggerUi = __webpack_require__(217);

var _swaggerUi2 = _interopRequireDefault(_swaggerUi);

var _swaggerUiStandalonePreset = __webpack_require__(316);

var _swaggerUiStandalonePreset2 = _interopRequireDefault(_swaggerUiStandalonePreset);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var yamlFront = __webpack_require__(317);

window.SwaggerUI = _swaggerUi2.default;
window.StandalonePreset = _swaggerUiStandalonePreset2.default;

var TykSwaggerUI = function () {
  function TykSwaggerUI(config) {
    var _this = this;

    _classCallCheck(this, TykSwaggerUI);

    this.config = config;
    this.getSwaggerDefinition(config.url).then(function (rsp) {
      if ((typeof rsp === 'undefined' ? 'undefined' : _typeof(rsp)) === 'object') {
        _this.swaggerDefinition = rsp;
      } else if (_this.isJsonString(rsp)) {
        _this.swaggerDefinition = JSON.parse(rsp);
      } else {
        var definition = yamlFront.safeLoadFront('---\n' + rsp + '\n---');
        _this.swaggerDefinition = definition;
      }

      _this.swaggerDefinition.url = config.url;
      _this.initSwagger();
    });
  }

  _createClass(TykSwaggerUI, [{
    key: 'isJsonString',
    value: function isJsonString(str) {
      var json = false;
      try {
        json = JSON.parse(str);
      } catch (e) {
        return json;
      }
      return json;
    }
  }, {
    key: 'initSwagger',
    value: function initSwagger() {
      var addHostPlugin = this.addHostPlugin.bind(this);

      this.swaggerUI = (0, _swaggerUi2.default)({
        deepLinking: false,
        dom_id: this.config.container,
        layout: 'BaseLayout',
        docExpansion: "none",
        sorter: "alpha",
        presets: [_swaggerUi2.default.presets.apis],
        plugins: [_swaggerUi2.default.plugins.DownloadUrl, _swaggerUiStandalonePreset2.default, addHostPlugin],
        spec: this.swaggerDefinition
      });
    }
  }, {
    key: 'getSwaggerDefinition',
    value: function getSwaggerDefinition(url) {
      return $.ajax({
        method: "GET",
        url: url
      });
    }
  }, {
    key: 'addHostPlugin',
    value: function addHostPlugin(system) {
      var rawUrl = this.config.url;
      return {
        wrapComponents: {
          info: function info(Original, system) {
            return function (_React$Component) {
              _inherits(WrappedInfoDisplay, _React$Component);

              function WrappedInfoDisplay(props) {
                _classCallCheck(this, WrappedInfoDisplay);

                var _this2 = _possibleConstructorReturn(this, (WrappedInfoDisplay.__proto__ || Object.getPrototypeOf(WrappedInfoDisplay)).call(this, props));

                _this2.swaggerVersion = system.getState().getIn(['spec', 'resolved', 'openapi']);
                _this2.handleHost = _this2.handleHost.bind(_this2);
                _this2.handleChange = _this2.handleChange.bind(_this2);
                _this2.buttonText = _this2.swaggerVersion === '3.0.0' ? 'Add Server' : 'Update host';
                _this2.buttonLabel = _this2.swaggerVersion === '3.0.0' ? 'Add Server' : 'Change Base url';

                _this2.state = {
                  v3: {
                    invalid: false,
                    submitted: false
                  },
                  v2: {
                    invalid: false,
                    submitted: false
                  },
                  value: _this2.swaggerVersion === '3.0.0' ? '' : _this2.props.host + _this2.props.basePath
                };
                return _this2;
              }

              _createClass(WrappedInfoDisplay, [{
                key: 'handleChange',
                value: function handleChange(event) {
                  this.setValue(event.target.value);
                }
              }, {
                key: 'setValue',
                value: function setValue(value) {
                  this.setState({ value: value });
                }
              }, {
                key: 'updateHost',
                value: function updateHost(value) {
                  var url = value.split('/');
                  var host = url[0];
                  var basePath = url[1] ? '/' + url[1] : '';

                  system.specActions.updateHost({
                    host: host,
                    basePath: basePath
                  });
                }
              }, {
                key: 'isValidHost',
                value: function isValidHost() {
                  return this.state.value.match(/^https?:\/\/[\-\w]+(\.[\-\w]+)*(:[0-9]+)?\/?(\/[.\-\w]*)*$/);
                }
              }, {
                key: 'handleHost',
                value: function handleHost(event) {
                  event.preventDefault();
                  if (this.swaggerVersion === '3.0.0') {
                    if (this.isValidHost()) {
                      system.specActions.addHost(this.state.value);
                      this.setValue('');
                      this.setState({
                        v3: {
                          invalid: false,
                          submitted: true
                        }
                      });
                    } else {
                      this.setState({
                        v3: {
                          invalid: true,
                          submitted: true
                        }
                      });
                    }
                  } else {
                    if (this.state.value) {
                      this.updateHost(this.state.value);
                      this.setState({
                        v2: {
                          invalid: false,
                          submitted: true
                        }
                      });
                    } else {
                      this.setState({
                        v2: {
                          invalid: true,
                          submitted: true
                        }
                      });
                    }
                  }
                }
              }, {
                key: 'getInputClass',
                value: function getInputClass() {
                  var classes = [];

                  if (this.state.v3.invalid || this.state.v2.invalid) {
                    classes.push('invalid');
                  }

                  return classes.join(' ');
                }
              }, {
                key: 'render',
                value: function render() {
                  var Input = system.getComponents().Input;
                  var Button = system.getComponents().Button;
                  var newProps = Object.assign({}, this.props, { url: rawUrl });
                  return _react2.default.createElement(
                    'div',
                    { className: 'swagger-host-manager' },
                    _react2.default.createElement(Original, newProps),
                    _react2.default.createElement(
                      'form',
                      { onSubmit: this.handleHost },
                      _react2.default.createElement(
                        'div',
                        { className: 'scheme-container' },
                        _react2.default.createElement(
                          'section',
                          { className: 'schemes wrapper block col-12 servers-wrapper' },
                          _react2.default.createElement(
                            'label',
                            { htmlFor: 'schemes', className: 'custom-url' },
                            _react2.default.createElement(
                              'span',
                              { className: 'schemes-title' },
                              this.buttonLabel
                            ),
                            _react2.default.createElement(Input, { className: this.getInputClass(), placeholder: 'http://localhost', onChange: this.handleChange, value: this.state.value, type: 'text' })
                          ),
                          _react2.default.createElement(
                            'button',
                            { className: 'btn try-out__btn', type: 'submit' },
                            this.buttonText
                          ),
                          this.state.v3.submitted ? this.state.v3.invalid ? _react2.default.createElement(
                            'div',
                            { className: 'text-danger swagger-message' },
                            'Please enter a valid host server'
                          ) : _react2.default.createElement(
                            'div',
                            { className: 'text-success swagger-message' },
                            'Server has been added successfully. Please select it from servers list!'
                          ) : null,
                          this.state.v2.submitted ? this.state.v2.invalid ? _react2.default.createElement(
                            'div',
                            { className: 'text-danger swagger-message' },
                            'Please enter a valid host server'
                          ) : _react2.default.createElement(
                            'div',
                            { className: 'text-success swagger-message' },
                            'Host has been successfully updated!'
                          ) : null
                        )
                      )
                    )
                  );
                }
              }]);

              return WrappedInfoDisplay;
            }(_react2.default.Component);
          }
        },
        statePlugins: {
          spec: {
            actions: {
              updateHost: function updateHost(str) {
                return {
                  type: "UPDATE_HOST",
                  payload: str
                };
              },
              addHost: function addHost(str) {
                return {
                  type: "ADD_HOST",
                  payload: str
                };
              }
            },
            reducers: {
              "UPDATE_HOST": function UPDATE_HOST(state, action) {
                state = state.setIn(['resolved', 'host'], action.payload.host).setIn(['resolved', 'basePath'], action.payload.basePath);
                return state;
              },
              "ADD_HOST": function ADD_HOST(state, action) {
                var servers = state.getIn(['resolved', 'servers']);
                servers = servers.unshift((0, _immutable.fromJS)({
                  url: action.payload
                }));

                state = state.setIn(['resolved', 'servers'], servers);
                return state;
              }
            }
          }
        }
      };
    }
  }]);

  return TykSwaggerUI;
}();

window.TykSwaggerUI = TykSwaggerUI;
/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(116)))

/***/ })

},[320]);
//# sourceMappingURL=swagger.min.js.map